---
title: Object.fromEntries()
slug: Web/JavaScript/Reference/Global_Objects/Object/fromEntries
tags:
  - JavaScript
  - Method
  - Object
  - Reference
---
<p>{{JSRef}}</p>

<p>The <code><strong>Object.fromEntries()</strong></code> method transforms a list of key-value pairs into an object.</p>

<div>{{EmbedInteractiveExample("pages/js/object-fromentries.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">Object.fromEntries(<var>iterable</var>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>iterable</var></code></dt>
 <dd>An iterable such as {{jsxref("Array")}} or {{jsxref("Map")}} or other objects implementing the <a href="/en-US/docs/Web/JavaScript/Reference/Iteration_protocols#The_iterable_protocol">iterable protocol</a>.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A new object whose properties are given by the entries of the iterable.</p>

<h2 id="Description">Description</h2>

<p>The <code>Object.fromEntries()</code> method takes a list of key-value pairs and returns a new object whose properties are given by those entries. The <var>iterable</var> argument is expected to be an object that implements an <code>@@iterator</code> method, that returns an iterator object, that produces a two element array-like object, whose first element is a value that will be used as a property key, and whose second element is the value to associate with that property key.</p>

<p><code>Object.fromEntries()</code> performs the reverse of {{jsxref("Object.entries()")}}.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Converting_a_Map_to_an_Object">Converting a Map to an Object</h3>

<p>With <code>Object.fromEntries</code>, you can convert from {{jsxref("Map")}} to {{jsxref("Object")}}:</p>

<pre class="brush: js notranslate">const map = new Map([ ['foo', 'bar'], ['baz', 42] ]);
const obj = Object.fromEntries(map);
console.log(obj); // { foo: "bar", baz: 42 }
</pre>

<h3 id="Converting_an_Array_to_an_Object">Converting an Array to an Object</h3>

<p>With <code>Object.fromEntries</code>, you can convert from {{jsxref("Array")}} to {{jsxref("Object")}}:</p>

<pre class="brush: js notranslate">const arr = [ ['0', 'a'], ['1', 'b'], ['2', 'c'] ];
const obj = Object.fromEntries(arr);
console.log(obj); // { 0: "a", 1: "b", 2: "c" }
</pre>

<h3 id="Object_transformations">Object transformations</h3>

<p>With <code>Object.fromEntries</code>, its reverse method {{jsxref("Object.entries()")}}, and <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array#Methods_2">array manipulation methods</a>, you are able to transform objects like this:</p>

<pre class="brush: js notranslate">const object1 = { a: 1, b: 2, c: 3 };

const object2 = Object.fromEntries(
  Object.entries(object1)
  .map(([ key, val ]) =&gt; [ key, val * 2 ])
);

console.log(object2);
// { a: 2, b: 4, c: 6 }</pre>

<div class="hidden">
<p>Please do not add polyfills on MDN pages. For more details, refer to: <a href="https://discourse.mozilla.org/t/mdn-rfc-001-mdn-wiki-pages-shouldnt-be-a-distributor-of-polyfills/24500">https://discourse.mozilla.org/t/mdn-rfc-001-mdn-wiki-pages-shouldnt-be-a-distributor-of-polyfills/24500</a></p>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-object.fromentries', 'Object.fromEntries')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.Object.fromEntries")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Object.entries()")}}</li>
 <li>{{jsxref("Object.keys()")}}</li>
 <li>{{jsxref("Object.values()")}}</li>
 <li>{{jsxref("Map.prototype.entries()")}}</li>
 <li>{{jsxref("Map.prototype.keys()")}}</li>
 <li>{{jsxref("Map.prototype.values()")}}</li>
</ul>
